= nng_cv_alloc(3supp)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_cv_alloc - allocate condition variable

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>
#include <nng/supplemental/util/platform.h>

typedef struct nng_cv nng_cv;

int nng_cv_alloc(nng_cv **cvp, nng_mtx *mtx);
----

== DESCRIPTION

The `nng_cv_alloc()` function allocates a condition variable, using
the mutex _mtx_, and returns it in _cvp_.

Every condition variable is associated with a mutex, which must be
owned when a thread waits for the condition using
xref:nng_cv_wait.3supp.adoc[`nng_cv_wait()`] or
xref:nng_cv_until.3supp.adoc[`nng_cv_until()`].
The mutex must also be owned when signaling the condition using the
xref:nng_cv_wake.3supp.adoc[`nng_cv_wake()`] or
xref:nng_cv_wake1.3supp.adoc[`nng_cv_wake1()`] functions.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient free memory exists.

== SEE ALSO

[.text-left]
xref:nng_cv_free.3supp.adoc[nng_cv_free(3supp)],
xref:nng_cv_until.3supp.adoc[nng_cv_until(3supp)],
xref:nng_cv_wait.3supp.adoc[nng_cv_wait(3supp)],
xref:nng_cv_wake.3supp.adoc[nng_cv_wake(3supp)],
xref:nng_cv_wake1.3supp.adoc[nng_cv_wake1(3supp)],
xref:nng_mtx_alloc.3supp.adoc[nng_mtx_alloc(3supp)],
xref:nng_strerror.3.adoc[nng_strerror(3)],
xref:nng.7.adoc[nng(7)]
